/*
ICQ 321973179 Vladikas
      . 
   ,   .
   00,     ,
 .     .
         . 
      00.
 A   
ra0 - 
ra1 - 
ra2   
ra3 
 B 
rb4   
rb5   

*/
#include <16F84A.h>

#FUSES NOWDT                 	//No Watch Dog Timer
#FUSES XT                    	//Crystal osc <= 4mhz
#FUSES PUT                   	//Power Up Timer
#FUSES NOPROTECT             	//Code not protected from reading
#use delay(clock=4000000)
#int_RB

//      picmaniac-.(pro-radio.ru)
#define bit_set(var,bitno) ((var) |= 1 << (bitno))    //   ()
#define bit_clr(var,bitno) ((var) &= ~(1 << (bitno))) //     ()

int32 timer=1000000+256;// ,   ,       
int flag=0b00000010;//
#bit flag_3ms     = flag.0
#bit mode		  = flag.1// 
#bit flag_500ms   = flag.2
#bit flag_100ms   = flag.3
#bit flag_buzzer  = flag.4
#bit flag_pervyj_raz = flag.5// 
#bit flag_sleep = flag.6//
#bit flag_des_ed = flag.7//   //1 -   

int flag_1=0b00000000;//
#bit flag_pik = flag_1.0// ""   

#byte INTCON = 0x0b

int16 l,k,n,p=3650;// 
int i,knopka_1,knopka_2,ed_min=0,des_min=0,sec=0,buzz=0,pik=0;


/*
  HGFEDCBA HGFEDCBA
  
0 11000000 00111111
1 11111001 00000110
2 10100100 01011011
3 10110000 01001111
4 10011001 01100110
5 10010010 01101101
6 10000010 01111101
7 11111000 00000111
8 10000000 01111111
9 10010000 01101111
*/

unsigned CHAR SYMBOLS[10] = 
//	  hgfedcba
//	  76543210
   {0b11000000,	//0
	0b11111001, //1
	0b10100100, //2
	0b10110000, //3
	0b10011001, //4
	0b10010010, //5
	0b10000010, //6
	0b11111000, //7
	0b10000000, //8
	0b10010000};//9     7 .

void Seven_segments (void)//  7-
{
output_low(PIN_A0);//  
output_low(PIN_A1);//  
if(flag_des_ed==0) //  
	{
	output_b (SYMBOLS[ed_min]); // 
	if (n>((3*p)/4))// 
		{
		output_bit(PIN_B7,(~bit_test(SYMBOLS[ed_min],7)));
		}
	output_high(PIN_A0);//  
	}
else
	{
	output_b (SYMBOLS[des_min]); // 
	if ((n<((3*p)/4))&&((2*p/4)<n))
		{
		output_bit(PIN_B7,(~bit_test(SYMBOLS[des_min],7)));// 
		}
	output_high(PIN_A1);//  
	}
flag_des_ed=1^flag_des_ed;//  
}
void button (void)// 
{
//OUTPUT_B(0xff);//    (   )
//    MPLAB SIM
set_tris_b (0b11111111);//1- , 0-
set_tris_a (0b00000011);//1- , 0-
knopka_1=~input(PIN_B4);//
knopka_2=~input(PIN_B5);//
set_tris_b (0b00000000);//1- , 0-
set_tris_a (0b00000000);//1- , 0-
///////////////////////
if(knopka_1||knopka_2)//   ,  
	{
	sec=0;// 
	n=0;
	p=3650;
	if (!flag_pervyj_raz)//  ?
		{
		if (flag_100ms)//  100
			{
			if(knopka_1)
				{
				if(++des_min>9)des_min=0;//  ,   9  
				}	
			if(knopka_2)
				{
				if(++ed_min>9)ed_min=0;//  ,   9  
				}
			flag_100ms=0;
			flag_pervyj_raz=1;
			flag_500ms=0;
			k=0;
			l=0;
			flag_pik=1;
			}
		else break;
		}
	else
		{
		if (flag_500ms)
			{
			if(knopka_1)
				{
				if(++des_min>9)des_min=0;//  ,   9  
				}	
			if(knopka_2)
				{
				if(++ed_min>9)ed_min=0;//  ,   9  
				}
			flag_500ms=0;
			k=0;	
			flag_pik=1;
			}
		else break;		
		}		
	if((ed_min!=0)||(des_min!=0))//     ,   
		{
		mode=0;	
		}	
	else//   00     
		{
		mode=1;	
		}	
	}
else
	{
	flag_pervyj_raz=0;
	}	
}
#int_timer0 
void RTCC_isr(void) 
{
timer-=256;
if(timer<256)
	{
	timer+=1000000;
	if(mode==0)//  
		{
		if (p>100){p-=50;}//      
		if(++sec==60)//    
			{
			sec=0;
			p=3650;//  
			if(--ed_min==255)// ?
				{
				ed_min=9;
				--des_min;
				}
			}
		if(!ed_min&&!des_min)//   !!!   00
			{	
			mode=1;//  
			flag_buzzer=1;// 
			}
		}
	else if(++sec==5) {flag_sleep=1;}// ""      
	}
if(++i>10)
	{
	i=0; flag_3ms=1;//   
	}
if(++k>2000)
	{
	k=0; flag_500ms=1;//    
	}
if(++l>500)
	{
	l=0; flag_100ms=1;// 
	}
if(mode==0)//     
	{
	if(++n>=p)	//  
		{
		n=0;
		}
	}
else {n=0;}//    
if(flag_buzzer&&mode)//    
	{
	if(++buzz==3)
		{
		buzz=0;
		output_toggle(PIN_A3);
		}	
	}	
if(flag_pik)
	{
	if(++buzz==3)
		{
		buzz=0;
		output_toggle(PIN_A3);
		if (++pik==50) 
			{
			pik=0;
			flag_pik=0;
			}
		}	
	}
}

void stop (void)// 
{
flag_sleep=0;
output_a (0x00);
output_b (0xff);
set_tris_b (0b11111111);//1- , 0-
port_b_pullups (1);
disable_interrupts(global); //  
disable_interrupts(INT_TIMER0); //   
bit_set (INTCON,3); //  RB4-7
n=input_b();//     ,  n  
clear_interrupt(INT_RB); //   RB
sleep();//
delay_cycles(1); // 
bit_clr (INTCON,3); //  RB4-7
sec=0;// 
des_min=0;// 
ed_min=0;// 
n=0;
p=3650;
flag_buzzer=0;// 
mode=1;//  
enable_interrupts(INT_TIMER0); //   
enable_interrupts(GLOBAL); //  
flag_pik=1;//
delay_ms(300);// 
flag_pik=1;//
}
void main()
{
	setup_timer_0(RTCC_INTERNAL|RTCC_DIV_1);
	bit_clr (INTCON,3); //  RB4-7
	disable_interrupts(INT_EXT);
	enable_interrupts(INT_TIMER0);
	enable_interrupts(GLOBAL);
	output_a (0);
	output_b (0);
	set_tris_a (0b00000011);//1- , 0-
	set_tris_b (0b11111111);//1- , 0-
	port_b_pullups (1);
	flag_pik=1;
while (1)
	{
	if(!ed_min&&!des_min) //  00
		{
		output_bit (PIN_A2, 0);// 
		if(flag_sleep) stop();//,    (    )
		}
	else //   00
		{
		output_bit (PIN_A2, 1); // 
		flag_sleep=0;
		}	
	if (flag_3ms)
		{
		Seven_segments();// 
		flag_3ms=0;
		button();//
		}
	}
}